	PROGRAM exx

	IMPLICIT NONE

        INCLUDE 'mpif.h'
        DOUBLE PRECISION x,y,z
        INTEGER myid, numprocs, ierr, nin, nout, yourid, i
        INTEGER maxbuf
        PARAMETER (maxbuf=10)
        DIMENSION x(maxbuf),y(maxbuf)
        

C					Initialize MPI
        CALL MPI_INIT( ierr ) 
C					Whats my rank in the group ?
	CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
C					How man processes ?
        CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
C					Only process 0 writes !
	IF(myid.EQ.0) THEN
	  WRITE(*,*) 
	  WRITE(*,*) 'There are ',numprocs,' processes running'
	  WRITE(*,*) 
	ENDIF
	
	IF( 2*(myid/2).EQ.myid) THEN
	  yourid = myid +1
	ELSE
	  yourid = myid -1 
	ENDIF

	z = myid
	nin = maxbuf
	DO i=1,nin
	  x(i) = z
	END DO

	CALL ExchangeD(yourid,nin,x,nout,y,maxbuf)

	WRITE(*,*) myid,' : ', nout,y(1) 

  999	CALL MPI_FINALIZE(ierr)

   91   FORMAT(I4,' --> color ',I4,' : ',4I4)
   92   FORMAT(50F8.2)
	END
