 	
C
C	Compute w:= w + s at nodes on  the boundary
C	South (ib==1), East (ib==2), North (ib==3), West (ib==4)
C 	
C	IN:	ib	define piece of boundary
C		nx, ny  number of points in x/y direction
C		s	vector of boundary values
C	I/O:	w	vector
C

	SUBROUTINE AddBound(ib,nx,ny,w,s)

	IMPLICIT NONE

	INTEGER ib,nx,ny,i,j,iediag,iehor
	DOUBLE PRECISION w(2,*), s(2,*)

	iediag = (nx-1) * (ny-1)
	iehor = (nx-1)*(ny-1) + (nx-1)*ny
	GOTO (10,20,30,40) ib
	GOTO 50
 
 10	CONTINUE
	DO i=1, nx-1
	   DO j=1,2
	      w(j,iediag+i) = s(j,i) + w(j,iediag+i)
	   END DO
	END DO
	GOTO 50
 20	CONTINUE
	DO i=1,ny-1
	   DO j=1,2
	      w(j,iehor+i*nx) = s(j,i) + w(j,iehor+i*nx)
	   END DO
	END DO
	GOTO 50

 30	CONTINUE
	DO i=1,nx-1
	   DO j=1,2
	      w(j,iehor-nx+i+1) = s(j,i) + w(j,iehor-nx+i+1)
	    END DO
	END DO
	GOTO 50
 40	CONTINUE
	DO i=1, ny-1
	   DO j=1,2
	      w(j,iehor+1+(i-1)*nx) = s(j,i) + w(j,iehor+1+(i-1)*nx)
	   END DO
	END DO
	GOTO 50

 50	CONTINUE

	RETURN
	END
