#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"

int main(argc,argv)
int argc;
char *argv[];
{
    int myid, numprocs, info, nummaster, all_num, all_myid; 
    char name[12];
    MPI_Comm master, slaves, all_nodes;

/*    printf("\n Hi salve\n"); */
    
    MPI_Init(&argc,&argv); 
    
    MPI_Comm_get_parent(&master);
    slaves = MPI_COMM_WORLD;

/*	How many slaves are started?  Which one I am ?			*/
        
    MPI_Comm_size(slaves,&numprocs);
    MPI_Comm_rank(slaves,&myid);
    printf("Slave %d  out of %d  \n",myid,numprocs);

    if (myid == 0)
    { printf("\n There are %d real slaves running.\n",numprocs); }

/*	Check master group						*/

    MPI_Comm_remote_size(master,&nummaster);
    if (myid == 0)
    { printf("\n There is %d master running.\n",nummaster); } 

/* 	Create one communication group for master and slaves.		*/
/*	master = 0,  slaves = 1..numspawn				*/

    MPI_Intercomm_merge(master, 1==1, &all_nodes);

    MPI_Comm_size(all_nodes,&all_num);
    MPI_Comm_rank(all_nodes,&all_myid);
    if (all_myid==0) printf("slave %d: %d procs in all_nodes\n",myid,all_num);
    printf("all %d  out of %d  \n",all_myid,all_num);

/* 	Greetings from all nodes					*/

/*    greetings(all_myid,all_num,all_nodes); */

/* 	Greetings from slave nodes					*/

/*    greetings(myid,numprocs,slaves); */

    calc(all_myid,all_num,all_nodes); 
    
    MPI_Finalize();

}

            
