#include <stdio.h>
#include <malloc.h>
#include "mpi.h"

void greetings(myid,num,icomm)
int myid,num;
MPI_Comm icomm;
{
    int  reslen, dest, i;
    char *name, *chbuf;
    MPI_Status stat;
   
    name = (char *)malloc(MPI_MAX_PROCESSOR_NAME*sizeof(char));
    chbuf = (char *)malloc(MPI_MAX_PROCESSOR_NAME*sizeof(char));

    MPI_Get_processor_name( name , &reslen);

    if(myid==0)
    {
      printf("   %d runs on %s \n",myid,name);
      for(i=1;i<num;i++)
      {
/*
	MPI_Recv(chbuf,MPI_MAX_PROCESSOR_NAME,MPI_CHAR,MPI_ANY_SOURCE,
          MPI_ANY_TAG,icomm, &stat);
*/

	MPI_Recv(chbuf,MPI_MAX_PROCESSOR_NAME,MPI_CHAR,i,
          MPI_ANY_TAG,icomm, &stat);

        printf("   %d runs on %s \n",stat.MPI_SOURCE,chbuf);
      }
    }
    else
    {
        dest = 0;
	MPI_Send(name,MPI_MAX_PROCESSOR_NAME,MPI_CHAR,dest,myid,icomm);
    }
   free(chbuf); free(name); 
}
